Package com.sas.services.information.metadata

# Interface SoftwareComponentInterface

All Superinterfaces:
  `MetadataInterface`, `PublicObjectInterface`, `Remote`

All Known Subinterfaces:
  `ApplicationInterface`, `ConfiguredComponentInterface`, `ConnectServerInterface`, `ConnectSpawnerInterface`, `DataStepBatchServerInterface`, `FtpServerInterface`, `GridMonitoringServerInterface`, `HttpServerInterface`, `JavaBatchServerInterface`, `LogicalConnectServerInterface`, `LogicalDataStepBatchServerInteface`, `LogicalGridServerInterface`, `LogicalJavaBatchServerInterface`, `LogicalOSServerInterface`, `LogicalServerInterface`, `MSMQQueueManagerInterface`, `OperatingSystemServerInterface`, `OracleServerInterface`, `ProxyListInterface`, `QueueManagerInterface`, `SasInProcessServerInterface`, `ServerComponentInterface`, `ServerContextInterface`, `ServerInterface`, `ShareServerInterface`, `SPDSServerInterface`, `TableServerInterface`, `WebsphereQueueManagerInterface`

All Known Implementing Classes:
  `Application`, `OMRDatabaseServer`, `OMRHadoopServer`, `OMRPostgresServer`, `OMRProxyList`, `OMRSAPServer`, com.sas.services.information.metadata.OMRServer, com.sas.services.information.metadata.OMRServerComponent, com.sas.services.information.metadata.OMRSoftwareComponent, `OMRSPDSServer`

public interface SoftwareComponentInterface extends MetadataInterface

- ## Field Summary

  ### Fields inherited from interface com.sas.services.information.metadata.MetadataInterface

  `METADATA_STATE_DELETED, METADATA_STATE_DESTROYED, METADATA_STATE_NEW, METADATA_STATE_NORMAL, PERMISSION_READMETADATA, PERMISSION_WRITEMETADATA`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addDeployedComponent(ServerInterface server)`
  Add a DeployedComponent to this SoftwareComponent.
  `void`
  `addPropertyGroup(PropertyGroupInterface group)`
  Add a `PropertyGroupInterface` object to this SoftwareComponent.
  `void`
  `addSoftwareGroup(GroupInterface group)`
  Add a SoftwareGroup to this SoftwareComponent.
  `void`
  `addSoftwareTree(FolderInterface folder)`
  Add a SoftwareTree to this SoftwareComponent.
  `String`
  `getClassIdentifier()`
  Get the unique class identifier for the software.
  `List`
  `getDependentComponents()`
  Get the components that depend on this one.
  `List`
  `getDependsOnComponents()`
  Get the components that this component depends on.
  `List`
  `getDeployedComponents()`
  Get the list of DeployedComponents associated to this SoftwareComponent.
  `List<MetadataInterface>`
  `getImplementedObjects()`
  Get the list of objects that are implemented by the software described by this SoftwareComponent.
  `int`
  `getMajor()`
  Get the major release number as an integer.
  `int`
  `getMinor()`
  Get the minor release number as an integer.
  `String`
  `getPlatform()`
  Get the platform or language of the SoftwareComponent.
  `Map<String,String>`
  `getPrivateConfigurableProperties()`
  `String`
  `getProductIdentifier()`
  An ID representing the product.
  `String`
  `getProductName()`
  Get the name of the product this software comprises or is bundled with.
  `List`
  `getPropertyGroups()`
  Get the List of `PropertyGroupInterface` objects associated with this SoftwareComponent.
  `Map<String,String>`
  `getPublicConfigurableProperties()`
  `SoftwareComponentAttributes`
  `getSoftwareComponentAttributes()`
  Get the attributes of this component in a `SoftwareComponentAttributes` object.
  `List`
  `getSoftwareGroups()`
  Get the SoftwareGroups for this SoftwareComponent.
  `List`
  `getSoftwareTrees()`
  Get the List of SoftwareTrees for this SoftwareComponent.
  `String`
  `getSoftwareVersion()`
  Get the software version of the SoftwareComponent.
  `String`
  `getSpecVendor()`
  Get the name of the vendor that provided the specification.
  `String`
  `getSpecVersion()`
  Get the specification number implemented by the SoftwareComponent.
  `String`
  `getVendor()`
  Get the String with the vendor name.
  `String`
  `getVendorIdentifier()`
  Get the ID representing the software vendor.
  `void`
  `removeDeployedComponent(ServerInterface server)`
  Remove a DeployedComponent from this SoftwareComponent.
  `void`
  `removePropertyGroup(PropertyGroupInterface group)`
  Remove a `PropertyGroupInterface` object from the associated list.
  `void`
  `removeSoftwareGroup(GroupInterface group)`
  Remove a SoftwareGroup from this SoftwareComponent.
  `void`
  `removeSoftwareTree(FolderInterface folder)`
  Remove a Software tree from this SoftwareComponent.
  `void`
  `setClassIdentifier(String classIdentifier)`
  Set the class identifier for this SoftwareComponent.
  `void`
  `setDeployedComponents(List servers)`
  Set the List DeployedComponents on this SoftwareComponent.
  `void`
  `setImplementedObjects(List<MetadataInterface> objects)`
  Set the list of objects that are implemented by the software component described by this object.
  `void`
  `setMajor(int major)`
  Set the major release number.
  `void`
  `setMinor(int minor)`
  Set the minor release number.
  `void`
  `setPlatform(String platform)`
  Set the component platform.
  `void`
  `setProductIdentifier(String productIdentifier)`
  Set the product ID for this component.
  `void`
  `setProductName(String productName)`
  Set the name of the product this software is part of.
  `void`
  `setPropertyGroups(List groups)`
  Set the list of associated `PropertyGroupInterface` objects.
  `void`
  `setSoftwareComponentAttributes(SoftwareComponentAttributes attributes)`
  Set the attributes of this component using a `SoftwareComponentAttributes` object.
  `void`
  `setSoftwareGroups(List groups)`
  Set the List of SoftwareGroups on this SoftwareComponent.
  `void`
  `setSoftwareTrees(List folders)`
  Set the List of SoftwareTrees on this SoftwareComponent.
  `void`
  `setSoftwareVersion(String version)`
  Set the software version of the SoftwareComponent.
  `void`
  `setSpecVendor(String specVendor)`
  Set the name of the vendor that provided the specification.
  `void`
  `setSpecVersion(String specVersion)`
  Set the specification number implemented by the Software Component.
  `void`
  `setVendor(String vendor)`
  Set the vendor name string for the Software Component.
  `void`
  `setVendorIdentifier(String vendorIdentifier)`
  Set the ID representing the software vendor.

  ### Methods inherited from interface com.sas.services.information.metadata.MetadataInterface

  `add, addAccessControl, addAttribute, addAttributes, addDocument, addExtension, addGroup, addImplementor, addKeyword, addNoteTextStore, addNoteTextStore, addObjectProperty, addObjectProperty, addPermissions, addPrompt, addPropertySet, addRemark, addResponsibleParty, addTransactionListener, addUsedByPrototype, checkin, checkout, commit, copyTo, countAssociatedObjects, delete, deleteAttribute, deleteAttributes, destroy, getAccessControls, getAttribute, getAttributes, getAuthorizationUtil, getCreateDate, getCreatedBy, getDescription, getDocuments, getEntityKey, getEntityURL, getExtensions, getGroups, getGUID, getIdentities, getImplementors, getKeywords, getLockedBy, getModifiedBy, getModifyDate, getNoteTextStore, getNoteTextStores, getNoteTextStoresByRole, getObjectProperties, getParent, getParentPath, getParents, getPath, getPaths, getPermission, getPermissions, getPermissions, getPreviousVersionNames, getPrimaryPropertyGroup, getPrompt, getPrompts, getPropertyBag, getPropertySets, getRemarksList, getReposId, getRepository, getRepositoryEntity, getRepositoryName, getReposKey, getResponsibleParties, getState, getTrackingId, getType, getUsageVersion, getUsedByPrototypes, getUsingPrototype, getVersion, isAuthorized, isCompatible, isDeleted, isDestroyed, isObjectAlive, isReadCompatible, mapNameToFilesystem, mapUrlToFilesystem, moveTo, newServiceObject, refresh, removeAccessControl, removeDocument, removeExtension, removeGroup, removeImplementor, removeKeyword, removeNoteTextStore, removeObjectProperty, removePermissions, removePrompt, removePropertySet, removeResponsibleParty, removeResponsiblePartyByIdentity, removeUsedByPrototype, rollback, setAttribute, setAttributes, setDeleted, setDescription, setDocuments, setExtensions, setGroups, setGUID, setKeywords, setName, setNoteTextStores, setObjectProperties, setPermission, setPrimaryPropertyGroup, setPrompt, setPrompts, setRemarksList, setRepository, setUsingPrototype, startTransaction, toByteArray, transactionEvent, uncheckout, update, updateFromBag, version`

  ### Methods inherited from interface com.sas.services.information.publicobject.PublicObjectInterface

  `addProcessorInterface, getContainer, getIdentifier, getName, getObjectURI, getPathUrl, getProcessorInterface, getTypeDescriptor`

- ## Method Details

  - ### getSoftwareVersion

    String getSoftwareVersion() throws ServiceException, RemoteException
    Get the software version of the SoftwareComponent.
    Returns:
      The software version as a string.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setSoftwareVersion

    void setSoftwareVersion(String version) throws ServiceException, RemoteException
    Set the software version of the SoftwareComponent.
    Parameters:
      `version` - The software version string.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getMajor

    int getMajor() throws ServiceException, RemoteException
    Get the major release number as an integer.
    Returns:
      The major release number.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setMajor

    void setMajor(int major) throws ServiceException, RemoteException
    Set the major release number.
    Parameters:
      `major` - The integer representing the major release number.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getMinor

    int getMinor() throws ServiceException, RemoteException
    Get the minor release number as an integer.
    Returns:
      The minor release number
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setMinor

    void setMinor(int minor) throws ServiceException, RemoteException
    Set the minor release number.
    Parameters:
      `minor` - The integer representing the minor release number.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getVendor

    String getVendor() throws ServiceException, RemoteException
    Get the String with the vendor name.
    Returns:
      A String containing the vendor's name.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setVendor

    void setVendor(String vendor) throws ServiceException, RemoteException
    Set the vendor name string for the Software Component.
    Parameters:
      `vendor` - A String containing the vendor's name.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getSpecVersion

    String getSpecVersion() throws ServiceException, RemoteException
    Get the specification number implemented by the SoftwareComponent.
    Returns:
      The specification number represented by a String.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setSpecVersion

    void setSpecVersion(String specVersion) throws ServiceException, RemoteException
    Set the specification number implemented by the Software Component.
    Parameters:
      `specVersion` - A String with the specification number.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getSpecVendor

    String getSpecVendor() throws ServiceException, RemoteException
    Get the name of the vendor that provided the specification.
    Returns:
      The name of the specification vendor.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setSpecVendor

    void setSpecVendor(String specVendor) throws ServiceException, RemoteException
    Set the name of the vendor that provided the specification.
    Parameters:
      `specVendor` - The name of the specification vendor.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getVendorIdentifier

    String getVendorIdentifier() throws ServiceException, RemoteException
    Get the ID representing the software vendor.
    Returns:
      The ID String of the software vendor.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setVendorIdentifier

    void setVendorIdentifier(String vendorIdentifier) throws ServiceException, RemoteException
    Set the ID representing the software vendor.
    Parameters:
      `vendorIdentifier` - A string with the ID of the software vendor.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getClassIdentifier

    String getClassIdentifier() throws ServiceException, RemoteException
    Get the unique class identifier for the software. The class identifier should uniquely identify the type of software this SoftwareComponent represents.
    Returns:
      The classidentifier String.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setClassIdentifier

    void setClassIdentifier(String classIdentifier) throws ServiceException, RemoteException
    Set the class identifier for this SoftwareComponent. The class identifier should uniquely identify the type of software this component represents.
    Parameters:
      `classIdentifier` - The class identifier string.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getProductName

    String getProductName() throws ServiceException, RemoteException
    Get the name of the product this software comprises or is bundled with.
    Returns:
      The product name.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setProductName

    void setProductName(String productName) throws ServiceException, RemoteException
    Set the name of the product this software is part of.
    Parameters:
      `productName` - The product name string.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getPlatform

    String getPlatform() throws ServiceException, RemoteException
    Get the platform or language of the SoftwareComponent.
    Returns:
      The component platform String.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setPlatform

    void setPlatform(String platform) throws ServiceException, RemoteException
    Set the component platform. This is the platform or language. Examples are COM or Java.
    Parameters:
      `platform` - The platform String.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getProductIdentifier

    String getProductIdentifier() throws ServiceException, RemoteException
    An ID representing the product.
    Returns:
      The ID string representing this component's product.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setProductIdentifier

    void setProductIdentifier(String productIdentifier) throws ServiceException, RemoteException
    Set the product ID for this component.
    Parameters:
      `productIdentifier` - The ID of the product this component belongs to.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getSoftwareComponentAttributes

    SoftwareComponentAttributes getSoftwareComponentAttributes() throws ServiceException, RemoteException
    Get the attributes of this component in a `SoftwareComponentAttributes` object.
    Returns:
      The component attributes.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setSoftwareComponentAttributes

    void setSoftwareComponentAttributes(SoftwareComponentAttributes attributes) throws ServiceException, RemoteException
    Set the attributes of this component using a `SoftwareComponentAttributes` object.
    Parameters:
      `attributes` - The new attributes of this SoftwareComponent. Any non-null String will replace the current value, and any integer > 0.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getSoftwareGroups

    List getSoftwareGroups() throws ServiceException, RemoteException
    Get the SoftwareGroups for this SoftwareComponent.
    Returns:
      A List of GroupInterface objects.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### addSoftwareGroup

    void addSoftwareGroup(GroupInterface group) throws ServiceException, RemoteException
    Add a SoftwareGroup to this SoftwareComponent.
    Parameters:
      `group` - A new GroupInterface to add as a SoftwareGroup.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### removeSoftwareGroup

    void removeSoftwareGroup(GroupInterface group) throws ServiceException, RemoteException
    Remove a SoftwareGroup from this SoftwareComponent.
    Parameters:
      `group` - The Group to remove from the SoftwareGroups.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setSoftwareGroups

    void setSoftwareGroups(List groups) throws ServiceException, RemoteException
    Set the List of SoftwareGroups on this SoftwareComponent. If the list is null or empty, all SoftwareGroups will be disassociated.
    Parameters:
      `groups` - The list of GroupInterface objects to associate to this SoftwareComponent as SoftwareGroups.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getSoftwareTrees

    List getSoftwareTrees() throws ServiceException, RemoteException
    Get the List of SoftwareTrees for this SoftwareComponent.
    Returns:
      A List of FolderInterface objects representing the SoftwareTrees.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### addSoftwareTree

    void addSoftwareTree(FolderInterface folder) throws ServiceException, RemoteException
    Add a SoftwareTree to this SoftwareComponent.
    Parameters:
      `folder` - A FolderInterface object to add as a SoftwareTree.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### removeSoftwareTree

    void removeSoftwareTree(FolderInterface folder) throws ServiceException, RemoteException
    Remove a Software tree from this SoftwareComponent.
    Parameters:
      `folder` - The FolderInterface to remove from the SoftwareTrees.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setSoftwareTrees

    void setSoftwareTrees(List folders) throws ServiceException, RemoteException
    Set the List of SoftwareTrees on this SoftwareComponent. If the list is null or empty, all SoftwareTrees will be disassociated.
    Parameters:
      `folders` - The List of FolderInterface objects to associate to this SoftwareComponent as SoftwareTrees.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getDeployedComponents

    List getDeployedComponents() throws ServiceException, RemoteException
    Get the list of DeployedComponents associated to this SoftwareComponent.
    Returns:
      A List of ServerInterface objects representing the DeployedComponents on this SoftwareComponent.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### addDeployedComponent

    void addDeployedComponent(ServerInterface server) throws ServiceException, RemoteException
    Add a DeployedComponent to this SoftwareComponent.
    Parameters:
      `server` - The ServerInterface object to add as a DeployedComponent on this SoftwareComponent.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### removeDeployedComponent

    void removeDeployedComponent(ServerInterface server) throws ServiceException, RemoteException
    Remove a DeployedComponent from this SoftwareComponent.
    Parameters:
      `server` - The ServerInterface object to remove from the DeployedComponents.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setDeployedComponents

    void setDeployedComponents(List servers) throws ServiceException, RemoteException
    Set the List DeployedComponents on this SoftwareComponent. If the list is null or empty, all DeployedComponents will be disassociated.
    Parameters:
      `servers` - The List of ServerInterface objects to associate to this SoftwareComponent as DeployedComponents.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getPropertyGroups

    List getPropertyGroups() throws ServiceException, RemoteException
    Get the List of `PropertyGroupInterface` objects associated with this SoftwareComponent.
    Returns:
      A List of `PropertyGroupInterface` objects associated to this SoftwareComponent.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### addPropertyGroup

    void addPropertyGroup(PropertyGroupInterface group) throws ServiceException, RemoteException
    Add a `PropertyGroupInterface` object to this SoftwareComponent.
    Parameters:
      `group` - A `PropertyGroupInterface` object to associate to this SoftwareComponent.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### removePropertyGroup

    void removePropertyGroup(PropertyGroupInterface group) throws ServiceException, RemoteException
    Remove a `PropertyGroupInterface` object from the associated list.
    Parameters:
      `group` - A `PropertyGroupInterface` object to remove from the associated list.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setPropertyGroups

    void setPropertyGroups(List groups) throws ServiceException, RemoteException
    Set the list of associated `PropertyGroupInterface` objects.
    Parameters:
      `groups` - A List of associated `PropertyGroupInterface` objects.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getDependentComponents

    List getDependentComponents() throws ServiceException, RemoteException
    Get the components that depend on this one. This association is going "down" the dependency chain.
    Returns:
      A List of SoftwareComponentInterface objects that depend on this one.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getDependsOnComponents

    List getDependsOnComponents() throws ServiceException, RemoteException
    Get the components that this component depends on. This association is going "up" the dependency chain.
    Returns:
      A List of SoftwareComponentInterface objects that this one depends on.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getPublicConfigurableProperties

    Map<String,String> getPublicConfigurableProperties() throws ServiceException, RemoteException
    Throws:
      `ServiceException`
      `RemoteException`

  - ### getPrivateConfigurableProperties

    Map<String,String> getPrivateConfigurableProperties() throws ServiceException, RemoteException
    Throws:
      `ServiceException`
      `RemoteException`

  - ### getImplementedObjects

    List<MetadataInterface> getImplementedObjects() throws ServiceException, RemoteException
    Get the list of objects that are implemented by the software described by this SoftwareComponent.
    Returns:
      a List of MetadataInterface objects that are implemented by this component.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setImplementedObjects

    void setImplementedObjects(List<MetadataInterface> objects) throws ServiceException, RemoteException
    Set the list of objects that are implemented by the software component described by this object.
    Parameters:
      `objects` - The list of objects implemented by this one.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.